/*
    Copyright (C) 2006  Robert Nelson

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#pragma once

class CPEExecutable
{
   typedef  struct _STAB_ENTRY
   {
      DWORD dwString;
      BYTE  byType;
      BYTE  byOtherField;
      WORD  wDescription;
      DWORD dwValue;
   }  STAB_ENTRY, *PSTAB_ENTRY;

public:
   CPEExecutable(void);
   ~CPEExecutable(void);

   void SetFilename(LPCSTR lpszName);
   bool ConvertDebug();

protected:
   void FreeData();

   bool ReadNTHeaders(int fd);
   bool ReadStabsDebug(int fd);
   bool WriteDebugDirectories(int fd);
   bool WriteCodeViewData(int fd);
   DWORD WriteCodeViewSymbols(int fd);

private:
   std::string                   m_strFileName;
   std::string                   m_strModuleName;

   DWORD                         m_dwNtHeaderOffset;
   IMAGE_NT_HEADERS              m_NtHeaders;
   int                           m_nSections;
   PIMAGE_SECTION_HEADER         m_Sections;
   IMAGE_DEBUG_DIRECTORY         m_DebugDirs[2];

   int                           m_idxDebugSection;

   DWORD                         m_nStabs;
   DWORD                         m_dwStringSize;
   PSTAB_ENTRY                   m_pStabs;
   LPCSTR                        m_pStrings;
};
